5  '(C) Science Specialists, Inc., 1986.
10 DIM R(4,4,20),Z(4,4),S(4,4,20),B(4,4)
15 KEY OFF
20 '---------------------------------MENU----------------------------------
30 SCREEN 0:COLOR 7,0:CLS
40 COLOR 14,9:LOCATE 1,15:FOR A= 1 TO 56:PRINT CHR$(42);:NEXT A:LOCATE 2,15:PRINT"** USE OF HOMOGENEOUS TRANSFORMATION MATRICES (HMT'S) **":LOCATE 3,15
50 PRINT"**            TO DETERMINE ROBOT GEOMETRY             **":LOCATE 4,15:PRINT"********************************************************"
60 LOCATE 6,15 :PRINT"********************************************************"
70 LOCATE 7,15:PRINT"* 1=ENTER NEW TRANSFORM LIST (LINK LIST)               *"
80 LOCATE 8,15:PRINT"* 2=MODIFY TRANSFORM LIST OR VIEW HTM's                *"
90 LOCATE 9,15:PRINT"* 3=SEND HTM's TO PRINTER                              *"
100 LOCATE 10,15:PRINT"* 4=SEND PARTIAL PRODUCTS, LINK MATRICES TO PRINTER    *"
110 LOCATE 11,15:PRINT"* 5=DISPLAY ROLL,  PITCH  &  YAW                       *"
120 LOCATE 12,15:PRINT"* 6=DISPLAY HAND TRANSFORM                             *"
130 LOCATE 13,15:PRINT"* 7=DISPLAY CONVENTIONS USED FOR DATA ENTRY            *"
140 LOCATE 14,15:PRINT"* 8=VIEW LINK ASSEMBLAGE                               *"
142 LOCATE 15,15:PRINT"* 9=SAVE LINK ASSEMBLAGE                               *"
144 LOCATE 16,15:PRINT"*10=LOAD LINK ASSEMBLAGE                               *"
146 LOCATE 17,15:PRINT"*11=EXIT                                               *"
150 LOCATE 18,15 :PRINT"********************************************************"
160 '------------------------MAIN ENTRY ROUTINE-----------------------------
170 LOCATE 20,10:INPUT "INPUT CHOICE";II:IF II<1 OR II>11 THEN 30
180 ON II GOTO 190,1080,490,1030,1290,850,1390,680,6000,7000,8000:GOTO 30
190 CLS:INPUT "INPUT # OF JOINTS + ARM SEGMENTS"; N
200 PRINT"INITIALIZING ARRAYS"
210 FOR R=1 TO 4:FOR C=1 TO 4:FOR G=1 TO N:R(C,R,G)=0:NEXT:NEXT:NEXT
220 G=1
230 FOR T= 1 TO N
240 FOR S= 1 TO 4
250 R(S,S,T)=1:NEXT S:NEXT T
260 IF G=N+1 THEN 470
270 CLS:PRINT"TRANSFORM # ";G :PRINT"CHOSE ONE: R=ROTATION,      T=TRANSLATION"
280 A$=INKEY$:IF A$="" THEN 280
290 IF A$="R" OR A$="T" OR A$="r" OR A$="t" THEN 300 ELSE 280
300 IF A$="R" OR A$="r" THEN GOSUB 330:GOTO 260
310 PRINT"INPUT X,Y, & Z TRANSLATIONS--(e.g. 40,0,0)":INPUT R(4,1,G),R(4,2,G),R(4,3,G)
320 G=G+1: GOTO 260
330 PRINT"AXIS OF ROTATION?"
340 X$=INKEY$
350 IF X$="X" OR X$="x" THEN V=1 ELSE IF X$="Y" OR X$="y" THEN V=2 ELSE IF X$="Z" OR X$="z" THEN V=3 ELSE 340
360 INPUT"ENTER ANGLE OF ROTATION FOLLOWED BY 'ENTER': ";A:A=A*3.141592/180
370 IF V=2 THEN A=-A
380 FOR T=1 TO 3: FOR S=1 TO 3
390 IF S=V OR T=V THEN 450
400 Q=Q+1
410 IF Q=1 THEN R(S,T,G)=COS(A)
420 IF Q=2 THEN R(S,T,G)=-SIN(A)
430 IF Q=3 THEN R(S,T,G)=SIN(A)
440 IF Q=4 THEN R(S,T,G)=COS(A)
450 NEXT S:NEXT T
460 Q=0:G=G+1:RETURN
470 CLS:GOTO 560
480 '-----------------------HTM PRINT ROUTINE-------------------------------
490 LPRINT:LPRINT"HOMOGENEOUS TRANSFORMATION MATRICES":LPRINT"****************************************************************************":FOR G=1 TO N:LPRINT"MATRIX #   ";G:FOR R=1 TO 4
500 LPRINT R(1,R,G);TAB(15);R(2,R,G);TAB(30);R(3,R,G);TAB(45);R(4,R,G)
510 NEXT R
520 LPRINT"****************************************************************************"
530 NEXT G
540 GOTO 800
550 '--------------------MATRIX MULTIPLICATION ROUTINE----------------------
560 CLS:PRINT"CALCULATION IN PROGRESS---":FOR G=1 TO N-1
570 FOR R=1 TO 4
580 FOR C=1 TO 4
590 FOR K=1 TO 4
600 IF G=1 THEN S(K,R,G)=R(K,R,G)
610 Z(C,R)=S(K,R,G)*R(C,K,G+1)+Z(C,R)
620 NEXT K:NEXT C:NEXT R
630 REM REPLACE OLD MATRIX WITH NEW
640 FOR C=1 TO 4: FOR R=1 TO 4
650 S(C,R,G+1)=Z(C,R):Z(C,R)=0
660 NEXT R: NEXT C
670 NEXT G
675 IF N=1 THEN FOR R=1 TO 4:FOR C=1 TO 4:S(R,C,1)=R(R,C,1):NEXT:NEXT
680 KEY OFF:SCREEN 2:LOCATE 21,1: PRINT"                FRONT VIEW               TOP VIEW               SIDE VIEW" :LOCATE 14,1:PRINT" (-X                 +X)(-X                 +X)(-Y                   +Y)"
690 LOCATE 4,1:PRINT"              +Z                     +Y                   +Z      ": FOR A= 0 TO 600 STEP 20:PSET(A,100):NEXT A
700 FOR A= O TO 200 STEP 10:PSET (100,A):PSET(280,A):PSET (460,A):NEXT A
710 FOR G=0 TO N: IF G=0 THEN LINE(100,100)-(101,100) ELSE LINE-(S(4,1,G)+100,-S(4,3,G)/2+100)
720 NEXT G
730 FOR G=0 TO N:IF G=0 THEN LINE(280,101)-(280,100) ELSE LINE-(S(4,1,G)+280,-S(4,2,G)/2+100)
740 NEXT G
750 FOR G=0 TO N:IF G=0 THEN LINE(460,101)-(460,100) ELSE LINE-(S(4,2,G)+460,-S(4,3,G)/2+100)
760 NEXT G
770 LOCATE 23,5:PRINT"TYPE ANY KEY TO ESCAPE"
780 O$=INKEY$:IF O$="" THEN 780 ELSE SCREEN 2:CLS:GOTO 30
790 SCREEN 2:SCREEN 0
800 LPRINT:LPRINT "THE PRODUCT OF THESE MATRICES IS:":LPRINT "****************************************************************************"
810 FOR R= 1 TO 4: LPRINT S(1,R,N);TAB(15);S(2,R,N);TAB(30);S(3,R,N);TAB(45);S(4,R,N):NEXT R
820 LPRINT "****************************************************************************"
830 CLS:GOTO 30
840 '--------------------DISPLAY HAND TRANSFORM-----------------------------
850 CLS:PRINT"      MATRIX REPRESENTING 'HAND' END POSITION"
860 PRINT"*************************************************"
870 FOR R=1 TO 4
880 S(4,R,N)=INT(S(4,R,N)*10000)/10000
890 PRINT USING "###.###      "; S(1,R,N);S(2,R,N);S(3,R,N);S(4,R,N)
900 NEXT R
910 PRINT"*************************************************"
920 LOCATE 20,1:PRINT"Where:COS(Xb:Xn)=cosine of angle between base frame X-AXIS and":PRINT"the hand frame X-AXIS":LOCATE 9,1
930 PRINT"      INTERPRETATION OF MATRIX"
940 PRINT"*************************************************"
950 PRINT" COS(Xb:Xn)  COS(Xb:Yn)  COS(Xb:Zn)  X-position  "
960 PRINT" COS(Yb:Xn)  COS(Yb:Yn)  COS(Yb:Zn)  Y-position  "
970 PRINT" COS(Zb:Xn)  COS(Zb:Yn)  COS(Zb:Zn)  Z-position  "
980 PRINT"    0            0           0       Scale Factor"
990 PRINT"*************************************************"
1000 IF INKEY$="" THEN 1000
1010 CLS: GOTO 30
1020 '--------------------LINK MATRIX PRINT ROUTINE--------------------------
1030 LPRINT:LPRINT"LINK MATRIX/PARTIAL PRODUCTS LIST":FOR G=1 TO N:LPRINT"***********************************************************************"
1040 LPRINT"TRANSFORM # ";G;
1050 FOR R= 1 TO 4:LPRINT:FOR C=1 TO 4
1060 LPRINT TAB(C*15);S(C,R,G);:NEXT C:NEXT R:LPRINT:NEXT G:CLS:LPRINT:LPRINT"***********************************************************************":GOTO 30
1070 '-----------------------HTM MODIFY ROUTINE------------------------------
1080 CLS:INPUT"SELECT # OF TRANSFORM TO BE MODIFIED OR VIEWED";FF:GOSUB 1240
1090 PRINT"H,RETURN=SCROLL HIGHER,L=SCROLL BACK,E=EXIT,R=REPLACE,I=INVERT,T=PRECALC"
1100 H$=INKEY$:IF H$="" THEN 1100
1110 IF H$="L" OR H$="l" THEN FF=FF-1:GOSUB 1240:GOTO 1090
1120 IF H$="H" OR H$=CHR$(13) OR H$="h" THEN FF=FF+1:GOSUB 1240:GOTO 1090
1130 IF H$="R" OR H$="r" THEN 1160
1140 IF H$="E" OR H$="e" THEN 560
1145 IF H$="I" OR H$="i" THEN GOSUB 3000:GOSUB 1240:GOTO 1090
1146 IF H$="T" OR H$="t" THEN GOSUB 5000:GOSUB 1240:GOTO 1090
1150 GOTO 1100
1160 FOR R=1 TO 4 :FOR C=1 TO 4:R(C,R,FF)=0:IF R=C THEN R(C,R,FF)=1
1170 NEXT C:NEXT R
1180 CLS(0):PRINT"TRANSFORM # ";FF:PRINT"CHOSE ONE: R=ROTATION,      T=TRANSLATION"
1190 A$=INKEY$:IF A$="" THEN 1190
1200 IF A$="R" OR A$="r" THEN 1210 ELSE 1220
1210 G=FF:GOSUB 330:GOSUB 1240:GOTO 1090
1220 PRINT"INPUT X,Y, & Z TRANSLATIONS--(e.g. 40,0,0)":INPUT R(4,1,FF),R(4,2,FF),R(4,3,FF):GOSUB 1240:GOTO 1090
1230 G=G+1: GOTO 260
1240 IF FF>N THEN FF=1 ELSE IF FF<1 THEN FF=N
1250 CLS:PRINT"TRANSFORM #";FF
1260 FOR R= 1 TO 4: FOR C= 1 TO 4
1270 PRINT TAB(8*C-8);:PRINT USING"###.###";R(C,R,FF);:NEXT C:PRINT:NEXT R:GOSUB 2000: RETURN
1280 '--------------------DISPLAY ROLL, PITCH, YAW---------------------------
1290 CLS:PRINT"TRANSFORM   ROLL     PITCH    YAW"
1300 FOR A=1 TO N:PRINT A;"       ";
1310 IF S(3,3,A)=0 AND S(2,3,A)=0  THEN REV=1:IF S(1,3,A)>0 THEN P=-3.1415/2 ELSE P=3.1415/2 ELSE 1315
1311 GOTO 1330
1315 IF S(3,3,A)=0 THEN YAW=3.14159/2*SGN(S(2,3,A)) ELSE IF S(3,3,A)<0 THEN YAW=ATN(S(2,3,A)/S(3,3,A))+3.1415 ELSE YAW=ATN(S(2,3,A)/S(3,3,A))
1316 IF S(1,1,A)=0 THEN R=SGN(S(3,2,A))*3.14159/2 ELSE IF S(1,1,A)>0 THEN R=ATN(S(1,2,A)/S(1,1,A)) ELSE R=3.14159+ATN(S(1,2,A)/S(1,1,A))
1317 IF R=0 THEN COZ=S(3,3,A)/COS(YAW) ELSE COZ=S(1,1,A)/COS(R)
1318 IF COZ<0 THEN P=ATN(-S(1,3,A)/COZ)+3.1415 ELSE IF COZ>0 THEN P=ATN(-S(1,3,A)/COZ)
1330 IF REV=1 THEN YAW=10000:P=10000:REV=0
1340 YAW=YAW/3.141592*180:P=P/3.141592*180:R=R/3.141592*180:PRINT USING "###.###  ";R;P;YAW
1350 NEXT A
1360 O$=INKEY$:IF O$="" THEN 1360
1370 CLS:GOTO 30
1380 XX=ATN(AA/(SQR(1-AA^2))):RETURN
1390 CLS
1400 PRINT"POSITIVE ROTATION IS VIEWED AS COUNTERCLOCKWISE WHEN LOOKING DOWN THE"
1410 PRINT"POSITIVE AXIS OF ROTATION TOWARD THE ORIGIN.  THE FRAME OF REFERENCE "
1420 PRINT"IS MOVED ALONG THE FRAME OF THE ROBOT OR LINK MATRIX SYSTEM STARTING "
1430 PRINT"AT THE BASE OF THE ROBOT OR AT 0,0,0 ON THE FRAME. USE IN SEQUENCE"
1440 PRINT"THE TRANSFORMATIONS YOU HAVE ENTERED TO DIRECT THE ACTIONS OF THE    "
1450 PRINT"TRI-AXIS.  X,Y, Z OPERATIONS ARE REFERENCED TO A LEFT HANDED COORDI- "
1460 PRINT"NATE FRAME.  i.e. THE POSITIVE AXES OF X, Y AND Z APPEAR TO OCCUR IN"
1470 PRINT"COUNTERCLOCKWISE ORDER WHEN VIEWED FROM ABOVE.  ROLL, PITCH, AND YAW "
1480 PRINT"ARE CALCULATED USING FORMULAS OF IEEE ROBOTICS TUTORIAL BY K.S. FU. "
1490 PRINT"  "
1500 IF INKEY$="" THEN 1500
1510 GOTO 30
1520 R$=INKEY$:IF R$="" GOTO 1520
1530 PRINT ASC(R$)
1540 KEY OFF:SCREEN 1:LOCATE 21,1: LOCATE 14,1:PRINT" (-Y                                                           +Y)"
1550 KEY OFF:SCREEN 1:LOCATE 21,1: LOCATE 14,1:PRINT" (-Y                                                           +Y)"
1560 LOCATE 4,1:PRINT"                                     X      ": FOR A= 0 TO 320 STEP 20:PSET(A,100):NEXT A
1570 FOR A= O TO 200 STEP 10:PSET (160,A):NEXT A
1580 FOR G=0 TO N: IF G=0 THEN LINE(100,100)-(101,100) ELSE LINE-(S(4,2,G)+100,-S(4,1,G)/2+100)
1590 NEXT G
1600 FOR G=0 TO N:IF G=0 THEN LINE(280,101)-(280,100) ELSE LINE-(S(4,2,G)+280,-S(4,3,G)/2+100)
1605 next g
2000 PRINT:IF R(1,1,FF)=1 AND R(2,2,FF)=1 AND R(3,3,FF)=1 THEN PRINT "TRANSLATE ";:PRINT USING "###.##,";R(4,1,FF);R(4,2,FF);R(4,3,FF) ELSE CLAG=1:GOTO 2010
2005 RETURN
2010 IF R(1,1,FF)=1 THEN CLAG=0:PRINT "ROTATION, X-AXIS, ";:REV=ATN(R(2,3,FF)/R(2,2,FF)):IF R(2,2,FF)<0 THEN REV=REV+3.1415
2011 IF R(2,2,FF)=1 THEN CLAG=0:PRINT "ROTATION, Y-AXIS, ";:REV=ATN(-R(1,3,FF)/R(1,1,FF)):IF R(1,1,FF)<0 THEN REV=REV+3.1415
2012 IF R(3,3,FF)=1 THEN CLAG=0:PRINT "ROTATION, Z-AXIS, ";:REV=ATN(R(1,2,FF)/R(1,1,FF)):IF R(1,1,FF)<0 THEN REV=REV+3.1415
2013 IF CLAG=0 THEN PRINT USING" ###.##";REV*180/3.141592
2014 CLAG=0:RETURN
3000 LOCATE 15,12:PRINT"MATRIX INVERSION IN PROCESS":FOR R=1 TO 4:FOR C=1 TO 4:B(R,C)=0:IF R=C THEN B(R,C)=1
3010 NEXT:NEXT
3020 FOR R=1 TO 4:FOR C=R TO 4
3022 IF R(C,R,FF)<>0 THEN tvc=c:c=4 : flieg=0 else flieg=1
3023 next c
3024 if flieg=1 then  PRINT"SINGULAR MATRIX":RETURN else c=tvc
3025 FOR K=1 TO 4
3030 TEMP=R(R,K,FF)
3040 R(R,K,FF)=R(C,K,FF)
3050 R(C,K,FF)=TEMP
3060 TEMP=B(R,K)
3070 B(R,K)=B(C,K)
3080 B(C,K)=TEMP
3090 NEXT k
3100 TEMP=1/R(R,R,FF)
3110 FOR K=1 TO 4
3120 R(R,K,FF)=TEMP*R(R,K,FF)
3130 B(R,K)=TEMP*B(R,K)
3140 NEXT K
3150 FOR NW=1 TO 4
3160 IF NW=R THEN 3210
3170 T=-R(NW,R,FF)
3180 FOR K=1 TO 4
3185 R(NW,K,FF)=R(NW,K,FF)+T*R(R,K,FF)
3190 B(NW,K)=B(NW,K)+T*B(R,K)
3200 NEXT K
3210 NEXT NW:NEXT R
3230 FOR R=1 TO 4:FOR C=1 TO 4:R(R,C,FF)=B(R,C):NEXT:NEXT:RETURN
5000 PRINT"TRANSFER WHAT PARTIAL PRODUCT TO THIS MATRIX,'0'=ABORT,# < ";N
5010 INPUT TF:IF TF<1 OR TF>N THEN RETURN
5020 FOR R=1 TO 4:FOR C=1 TO 4:R(R,C,FF)=S(R,C,TF):NEXT:NEXT:RETURN
6000 CLS
6010 INPUT"ENTER FILE NAME FOR SAVING";GF$
6020 IF GF$="" THEN 30
6030 OPEN GF$ FOR OUTPUT AS #1
6040 PRINT #1,N
6050 FOR R=1 TO 4:FOR C=1 TO 4:FOR ggG=1 TO N:PRINT #1,R(R,C,ggG):NEXT:NEXT:NEXT
6060 CLOSE
6070 GOTO 30
7000 CLS
7010 INPUT"ENTER FILE NAME FOR LOADING";GF$
7020 IF GF$="" THEN 30
7030 OPEN GF$ FOR INPUT AS #1
7040 INPUT #1,N
7050 FOR R=1 TO 4:FOR C=1 TO 4:FOR ggG=1 TO N:INPUT #1,R(R,C,ggG):NEXT:NEXT:NEXT
7060 CLOSE
7080 GOSUB 550
7090 GOTO 30
8000 CLS:CLEAR:SYSTEM
